﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#IgnoreWarnings: 12

Private Sub Class_Globals	
	Private Surface As View
	Private lGdx As LibGDX
	Private Batch As lgSpriteBatch
	Private Camera As lgOrthographicCamera
	Private Blur As lgBlurShader
	Private tex As lgTexture
	Private byteBuffer() As Byte
	Private Config As lgConfiguration
	Private parentActivity As Activity
	Private ready As Boolean
End Sub

Sub Initialize(activity As Activity)	
	Config.useAccelerometer = False
	Config.useCompass       = False	
	Surface = lGdx.InitializeView2(Config, "LG")
	
	parentActivity          = activity
	parentActivity.AddView(Surface, _	
	parentActivity.Left,  parentActivity.Top, _
    parentActivity.Width, parentActivity.Height)
	
	Surface.Left            = activity.Left
	Surface.Top             = activity.Height
	Surface.Width           = activity.Width
	Surface.Height          = activity.Height		
End Sub

Sub Activate		
	byteBuffer = ScreenShot
	Surface.Top = parentActivity.Height
	Surface.BringToFront
	lGdx.Resume
End Sub

Sub Deactivate
	lGdx.Pause
	ready = False
	Surface.Top = parentActivity.Height
End Sub

Sub Destroy
	Deactivate
	Surface.RemoveView
End Sub

Sub Pause
	File.WriteString(File.DirInternalCache, "blurStatus", getisActive)
	If lGdx.IsInitialized Then lGdx.Pause
End Sub

Sub Resume
	If ( _
		File.Exists(File.DirInternalCache, "blurStatus") _
		And _
		File.ReadString(File.DirInternalCache, "blurStatus").ToLowerCase = "True" _
		And _
		lGdx.IsInitialized _
	) _
	Then
		lGdx.Resume
	End If
End Sub

Sub getisActive As Boolean
	Return Surface.Top == parentActivity.Top
End Sub

Private Sub Show_Blur(param As Object)
	If Surface.Top <> parentActivity.Top Then Surface.Top = parentActivity.Top
End Sub

Private Sub LG_Create
	lGdx.Graphics.ContinuousRendering = False
	Batch.Initialize
	Blur.Initialize(lGdx, Batch, 1)	
	Camera.Initialize
	Camera.SetToOrtho(False)	
	Camera.Update
End Sub

Private Sub LG_Resize(Width As Int, Height As Int)	
	If Not(ready) Then Return
	dim pixmap as lgPixmap
	pixmap.InitializeWithArray(byteBuffer, 0, byteBuffer.Length)
	If tex.IsInitialized Then tex.dispose
	tex.InitializeWithPixmap(pixmap)	
	Blur.Resize(Width, Height)
	Blur.AddTexture(tex, 0, 0, Surface.Width, Surface.Height)
	Blur.Apply
	Blur.Draw(0, 0, Surface.Width, Surface.Height)
	lGdx.CallSubUI("Show_Blur", Null)
End Sub

Private Sub LG_Render
End Sub

Private Sub ScreenShot As Byte()
	Dim Obj1, Obj2 As Reflector
	Dim bmp As Bitmap
	Dim c As Canvas
	Dim r As Rect
	r.Initialize(0, 0, 100%x, 100%y)
	Obj1.Target = Obj1.GetActivityBA
	Obj1.Target = Obj1.GetField("vg")
	bmp.InitializeMutable(parentActivity.Width, parentActivity.Height)
	c.Initialize2(bmp)
	Dim args(1) As Object
	Dim types(1) As String
	Obj2.Target = c
	Obj2.Target = Obj2.GetField("canvas")
	args(0) = Obj2.Target
	types(0) = "android.graphics.Canvas"
	Obj1.RunMethod4("draw", args, types)   
	Dim Out As OutputStream
	Out.InitializeToBytesArray(0)
	bmp.WriteToStream(Out, 100, "PNG")
	Out.Close
	ready = True
	Return Out.ToBytesArray
End Sub

Private Sub LG_Resume
End Sub

Private Sub LG_Pause
End Sub

Private Sub LG_Dispose
	Batch.dispose
	Blur.Dispose
End Sub